use std::ffi::OsString;

use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize)]
pub struct WaitResult {
    pub pid: u64,
    pub exit_code: u8,
}

#[derive(Clone, Copy, Debug, Serialize, Deserialize)]
pub enum ProcessStatus {
    Running,
    Exited(u8),
}

#[derive(Clone, Debug, Serialize, Deserialize)]
pub struct Process {
    pub pid: u64,
    pub stdio: [Option<(u64, u64)>; 3],
    pub cli_args: Vec<OsString>,
    pub status: ProcessStatus,
    pub parent: Option<u64>,
    pub children: Vec<u64>,
}
